function d= test_OBB(r,minf,n,d)
    fprintf('test for the bounding box problem. \n');
    r = 1;
    rand('state', r);
    randn('state', r);  
    fprintf('which algorithm do you want to test: \n');
    fprintf('1, RQNBM \n');
    fprintf('2, RPBM \n');
    fprintf('3, RPBM \n');
    fprintf('4, REsubGA \n');
    fprintf('5, M-RQNBM \n');    
    fprintf('otherwise, break \n');
    method = input('please input: ');
    if(method < 1 || method > 5)
        fprintf('exit! \n');
        return;
    end
    % fprintf('which retraction do you want to test: \n');
    % fprintf('1, exp \n');
    % fprintf('2, qf \n');
    % fprintf('otherwise, break \n');
    % Retraction = input('please input: ');
    Retraction = 1;
    % if(Retraction < 1 || Retraction > 2)
    %     fprintf('exit! \n');
    %     return;
    % end
    
    % fprintf('which vector transport do you want to test: \n');
    % fprintf('1, nonIso: vector transport by projection \n')
    % fprintf('2, Iso: parallel transport \n')
    % fprintf('3, Iso: direct-rotation with basis on tangent space \n')
    % fprintf('4, Iso: direct-rotation with basis on normal space \n')
    % fprintf('5, Iso: smooth basis on tangent space \n')
    % fprintf('6, Iso: smooth basis on normal space \n')
    % fprintf('7, Iso: intrinsic approach \n')
    % fprintf('8, Quo Iso: parallel transport \n')
    % fprintf('9, Quo Iso: direct-rotation with basis on horizontal space \n')
    % fprintf('10,Quo Iso: direct-rotation with basis on vertical space \n')
    % fprintf('11,Quo Iso: smooth basis on horizontal space \n')
    % fprintf('12,Quo Iso: smooth basis on vertical space \n')
    % fprintf('13,Quo Iso: intrinsic approach \n')
    % fprintf('otherwise, break \n');
    % VT = input('please input: ');
    VT = 7;
    % if(VT < 1 || VT > 13)
    %     fprintf('exit! \n');
    %     return;
    % end
    
    n = 1000;
    d = 10;
    minf = 0;
    
    x1.U = orth(randn(d, d)); 
    A = 0.75 * rand(d, n);
    H0 = eye(d * (d-1) * 0.5);
    N = d * (d-1) * 0.5;
    params.x0 = x1;
    params.H0 = H0;
    
    params.manifold = 3;
    params.error = 1e-4;
    params.minf = minf;
    params.err = 1e-5;
    params.tol = 1e-8;
    params.rho = 0.1;
    params.mu0 =0.18;
    params.minstepsize = eps;
    params.maxstepsize = 1;
    params.thetaA = 0.1;
    params.thetaL = 0.1;
    params.thetaR = 0.45;
    params.thetaT = 0.2;
    params.m = 8;
    params.D = 100;
    params.E = 1; 

    params.kappa = 0.25;   
    params.omega = 2;
    params.update =1;
    params.alpha = 1.2;
    params.m_L = 0.0002;
    params.mu_l = 26;
    params.max_L = 50;
    
    params.theta_epsilon = 0.1;
    params.theta_delta = 1; 
    params.c = 0.005;
    params.max_ls = 5000;
    params.delta = 1e-5;
       
    if (method == 1)
        params.t = 2^d * N; 
        params.Gamma = 50;
        params.gamma = 0.15;       
        params.max_t = inf; 
    elseif (method == 2)
        params.epsilon = 0.05;
        params.max = inf;
        params.max_t = 5000;
    elseif (method == 3)       
        params.epsilon = 0.05; 
        params.max = inf;
        params.max_t = 5000;
    elseif (method == 4)
        Retraction = 1;
        VT = 1;
        params.epsilon = 0.1;
        params.gamma = 0.5;
        params.max_t = 5000;
        params.manifold = 1;      
    else        
        params.t = 500; 
        params.Gamma = 1000;
        params.gamma = 0.15;   
        params.max_t = inf; 
    end
    params.retraction = Retraction;
    params.vector_transport = VT;
    fns = {};
    
    times = 0;
    total_timecost = 0;
    while(total_timecost < 60 && times < 1)
        fprintf('%d: ', times);
        [X, Y, F, timecost,tt] = driver_OBB(A, method, fns, params);
        total_timecost = total_timecost + timecost;
        times = times + 1;
    end
    d=[F(end).f length(F) total_timecost tt];
    fprintf('average time cost of %d times is %f. \n', times, total_timecost / times);
end